package com.ibm.stg.rtc.ext.common;

import com.ibm.team.repository.common.IItemHandle;
import com.ibm.team.repository.common.UUID;

/**
 * @author Kyle Christianson
 *
 */
public class ItemHandleKey<T extends IItemHandle>{

	T itemhandle;
	UUID itemUUID;

	public ItemHandleKey(T itemHandle){
		this.itemhandle = itemHandle;
		this.itemUUID = itemHandle.getItemId();
	}

	public T getItemHandle(){
		return this.itemhandle;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object o) {
		if (o instanceof ItemHandleKey) {
			ItemHandleKey<?> otherKey = (ItemHandleKey<?>) o;
			return otherKey.itemUUID.equals(this.itemUUID);
		}
		return false;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		return this.itemUUID.hashCode();
	}

}
