package com.ibm.stg.rtc.ext.common;

import com.ibm.team.process.common.IProcessConfigurationElement;

/**
 * @author Kyle Christianson
 *
 */
public class Stream {

	private String name;
	private String uuid;
	private InternalRelease ir;

	private IProcessConfigurationElement element;

	public Stream(InternalRelease internalRelease, IProcessConfigurationElement element){
		if(element == null){
			throw new IllegalArgumentException("Stream constructor cannot accept a null element");
		}
		this.element = element;
		this.name = getRequiredAttribute(element, ConfigurationHelper.ATTR_NAME);
		this.uuid = getRequiredAttribute(element, ConfigurationHelper.ATTR_UUID);
		this.ir = internalRelease;
	}

	private String getRequiredAttribute(IProcessConfigurationElement element, String attribute){
		String value = element.getAttribute(attribute);
		if(value == null || value.length() == 0){
			throw new IllegalStateException("Each stream element must contain a '" + attribute + "' attribute.");
		}

		return value;
	}

	public String getName() {
		return name;
	}

	public String getUuid() {
		return uuid;
	}

	public InternalRelease getOwningInternalRelease(){
		return ir;
	}
}
