package com.ibm.stg.rtc.ext.common;

import java.util.ArrayList;
import java.util.HashMap;

import com.ibm.team.process.common.IProcessConfigurationElement;

public class XMLHelper {

	private static HashMap getTagAttributes(IProcessConfigurationElement configurationElement) {
		HashMap attributeIDs = new HashMap();

		for (String attributeName : configurationElement.getAttributeNames()) {
			if (attributeIDs.containsKey(configurationElement.getName() + "_" + attributeName)) {
				Object tempID = attributeIDs.get(configurationElement.getName() + "_" + attributeName);
				if (tempID instanceof ArrayList) {
					((ArrayList) tempID).add(configurationElement.getAttribute(attributeName));
				} else {
					ArrayList<String> list = new ArrayList();
					list.add((String) tempID);
					list.add(configurationElement.getAttribute(attributeName));
					attributeIDs.put(configurationElement.getName() + "_" + attributeName, list);
				}
			} else {
				attributeIDs.put(configurationElement.getName() + "_" + attributeName, configurationElement.getAttribute(attributeName));
			}
		}
		IProcessConfigurationElement[] childConfigurationElements = configurationElement.getChildren();
		ArrayList childElements = new ArrayList();
		for (IProcessConfigurationElement childConfigurationElement : childConfigurationElements) {
			childElements.add(getTagAttributes(childConfigurationElement));
			attributeIDs.put(configurationElement.getName(), childElements);
		}
		return attributeIDs;
	}

	public static ArrayList<String> getXMLElement(IProcessConfigurationElement configurationElement, String tagName, String attributeName, String attributeValue, String returnAttributeName) {
		ArrayList xmlAttributes = new ArrayList();

		IProcessConfigurationElement[] configurationElements = configurationElement.getChildren();
		for (IProcessConfigurationElement childConfigurationElement : configurationElements) {
			if (childConfigurationElement.getName().equals(tagName) && attributeValue != null) {
				if (attributeValue.equals(childConfigurationElement.getAttribute(attributeName))) {
					xmlAttributes.add(childConfigurationElement.getAttribute(returnAttributeName));
				}

			} else {
				IProcessConfigurationElement[] childElements = childConfigurationElement.getChildren();
				for (IProcessConfigurationElement childElement : childElements) {
					xmlAttributes.addAll(getXMLElement(childElement, tagName, attributeName, attributeValue, returnAttributeName));
				}
			}
		}
		return xmlAttributes;
	}

	// Get tagName Elements
	private static ArrayList<IProcessConfigurationElement> getXMLElements(IProcessConfigurationElement configurationElement, String tagName) {
		ArrayList xmlElements = new ArrayList();

		if (configurationElement.getName().equals(tagName)) {
			xmlElements.add(configurationElement);
		} else {
			IProcessConfigurationElement[] childElements = configurationElement.getChildren();
			for (IProcessConfigurationElement childElement : childElements) {
				xmlElements.addAll(getXMLElements(childElement, tagName));
			}
		}
		return xmlElements;
	}

	public static ArrayList<String> getAttributes(IProcessConfigurationElement configurationElement, String tagName, String attributeName) {
		ArrayList<IProcessConfigurationElement> xmlElements = getXMLElements(configurationElement, tagName);
		ArrayList attributeList = new ArrayList();

		for (IProcessConfigurationElement configElement : xmlElements) {
			attributeList.add(configElement.getAttribute(attributeName));
		}
		return attributeList;
	}

	public static ArrayList<String> getAttributesWithCondition(IProcessConfigurationElement configurationElement, String tagNameCondition, String attributeNameCondition, String attributeValueCondition, String tagNameReturn, String attributeReturnName) {
		ArrayList<IProcessConfigurationElement> xmlElements = getXMLElements(configurationElement, tagNameReturn);
		ArrayList attributeList = new ArrayList();

		for (IProcessConfigurationElement configElement : xmlElements) {
			if (tagNameCondition.equals(tagNameReturn)) {
				if (configElement.getAttribute(attributeNameCondition).equals(attributeValueCondition)) {
					attributeList.add(configElement.getAttribute(attributeReturnName));
				}
			} else if (configElement.getParent() instanceof IProcessConfigurationElement) {
				IProcessConfigurationElement parentConfigElement = (IProcessConfigurationElement) configElement.getParent();
				if (parentConfigElement.getName().equals(tagNameCondition)) {
					if (parentConfigElement.getAttribute(attributeNameCondition).equals(attributeValueCondition)) {
						attributeList.add(configElement.getAttribute(attributeReturnName));
					}
				}
			}
		}
		return attributeList;
	}
}
