package com.ibm.stg.rtc.ext.stgdefect.common;

import com.ibm.team.workitem.common.model.IResolution;
import com.ibm.team.workitem.common.model.IWorkItem;
import com.ibm.team.workitem.common.model.Identifier;

/**
 * @author Kyle Christianson
 *
 */
public class STGDefectCommonTasks {

	/**
	 * Returns true if the work item's resolution is the duplicate resolution
	 * @param workItem
	 * @return
	 */
	public static boolean isResolutionDuplicate(IWorkItem workItem) {
		Identifier<IResolution> resolutionId = workItem.getResolution2();
		if(resolutionId != null){

			String resolutionValue = resolutionId.getStringIdentifier();

			if(resolutionValue != null){
				if(resolutionValue.equals(STGDefectCommonIDs.STG_DEFECT_RESOLUTION_DUPLICATE)){
					return true;
				}
			}
		}
		return false;
	}
}
