//<IBMPracticesSEglobals.inc>

/*
    Globally applicable constant & variable declarations for DOORS IBMPractices/SE scripts
    
    Version: 1.5.3
    Author: RJH
*/

/*
    CHANGE LOG
    
    When        Who     What
    --------------------------------------------------------------------------------------------------
    20080918	GSR	Updated version to 1.5.3 to work with IBMPractices/SE
    20080602	BW	Updated version to 1.5.2 (Support for updated Project Structure and Modules)
    20070928	BW	Updated version to 1.3.2 (Updated Module and Project Archives for Architecture Notebook fix)
    20070928	BW	Updated version to 1.3.1
    20070928	BW	Updated version to 1.3
    20070925	AF	Added functions for validating names and descriptions
    20070914	BW	Updated Version to 1.2.1
    20070711	BW	Converted from OpenUP to IBMPractices/ESW (new version: 1.1)
    20070621  RJH Initial Version.
*/

// To use: #include <project/IBMPractices/IBMPracticesglobals.inc>

const string strEmpty               = ""
const string strVersion             = "1.5.3"
const string strLongVersion         = "1.5.3.xx"
const string strBuildDate           = "Friday 29th July 2011"


const string strDOORSHOME           = getenv "DOORSHOME"
const string defaultPathToTemplates = strDOORSHOME "IBMPractices\\Templates\\"
const string aboutLogoPath          = strDOORSHOME "/lib/dxl/project/IBMPractices/about.bmp"
const string restoreErrorMessage    = "An error was encountered whilst attempting to create a new instance of this Project template:\n\n"
const string templatePath = "/00 Admin/Module Templates"

bool NameValidation(DB DBx, string nameString){
	bool b = isValidName(nameString)
	if(!b){
		ack(DBx, "Specified Name contains illegal characters")
	}
	return b 
}

bool DescValidation(DB DBx, string descString){
	bool b = isValidDescription(descString)
	if(!b){
		ack(DBx, "Specified Description contains illegal characters")
	}
	return b 
}