//<setTemplateDirectory.inc>

/*
    Set Project Specific IBMPractices/SE Template Directory
    
    Version: 1.2
    Author:  BW
*/

/*
    CHANGE LOG
    
    When        Who     What
    --------------------------------------------------------------------------------------------------
    20080918	GSR	Converted from IBMPractices/ESW to IBMPractices/SE (new version: 1.2)
    20070711	BW	Converted from OpenUP to IBMPractices/ESW (new version: 1.1)
    20070621    RJH     Abstracted default path to a variable, set to more useful default.
    20070625    RJH     Refactored & reorganised code, clean-up after blocking DB.
*/

//////////////////////////////////////
// Pragmas

pragma runLim, 0
#include <project/IBMPractices/IBMPracticesglobals.inc>


//////////////////////////////////////
// Local declarations / initialisation

string projectName              = strEmpty
string confFileName             = strEmpty
string processTemplateDirectory = strEmpty

DB  processTemplateDirectoryNameBox
DBE descriptionLabel, nameBox


//////////////////////////////////////
// Auxiliary Functions

void setProcessTemplateDirectoryForProject ()
{
	ConfStream outputStream = confWrite (confFileName, confSystem)
	outputStream << processTemplateDirectory strEmpty
	close outputStream
    
	//infoBox ("Process Template Directory for the " projectName " Project\nhas been successfully set to " processTemplateDirectory strEmpty)
}


//////////////////////////////////////
// DB/DBE Callbacks

void doSetTemplateDirectory (DB processTemplateDirectoryNameBox) 
{
    processTemplateDirectory = get nameBox
    setProcessTemplateDirectoryForProject()
	release processTemplateDirectoryNameBox
	processTemplateDirectoryNameBox = null
}

void doClose (DB processTemplateDirectoryNameBox)
{
    release processTemplateDirectoryNameBox
	processTemplateDirectoryNameBox = null
}


//////////////////////////////////////
// Main Program


if(!null (current Project))
{	
	projectName  = name (current Project)
	confFileName = projectName "_IBMPractices_Template_Directory" strEmpty
}
else
{
	errorBox "You must be inside a Project to run this utility."
	halt
}
          
processTemplateDirectoryNameBox = create ("Set Process Template Directory for Project", styleCentered)
descriptionLabel                = label (processTemplateDirectoryNameBox, ("Process Template Directory for Project '" projectName "':"))
nameBox                         = field (processTemplateDirectoryNameBox, null, defaultPathToTemplates, 55)
nameBox->"right"->"form"

ok (processTemplateDirectoryNameBox, ("Set"), doSetTemplateDirectory)
close (processTemplateDirectoryNameBox, true, doClose)
block processTemplateDirectoryNameBox