//<viewProcessWebsite.inc>

/*
    View Project Specific IBMPractices/SE Process Website
    
    Version: 1.2
    Author:  BW
*/

/*
    CHANGE LOG
    
    When        Who     What
    --------------------------------------------------------------------------------------------------
    20080918	GSR	Converted from IBMPractices/ESW to IBMPractices/SE (new version: 1.2)
    20070711	BW	Converted from OpenUP to IBMPractices/ESW (new version: 1.1)
    20070625    RJH     Refactored & reorganised code.
*/


//////////////////////////////////////
// Pragmas

pragma runLim, 0
#include <project/IBMPractices/IBMPracticesglobals.inc>


//////////////////////////////////////
// Local declarations / initialisation

string projectName       = strEmpty
string confFileName      = strEmpty
string processWebsiteURL = strEmpty


//////////////////////////////////////
// Auxiliary Functions

void viewProcessWebsiteForProject()
{
	if (confFileExists (confFileName, confSystem))
	{
		ConfStream inputStream = confRead (confFileName, confSystem)
		inputStream >> processWebsiteURL
		close inputStream

		activateURL(processWebsiteURL)
	}
	else
	{
		errorBox "No Process Website has been set for the " projectName " Project."
	}
}


//////////////////////////////////////
// Main Program

if(!null (current Project))
{	
	projectName  = name (current Project)
	confFileName = projectName "_Process_Website" strEmpty
}
else
{
	errorBox "You must be inside a Project to run this utility."
	halt
}
 
viewProcessWebsiteForProject()