'''
Created on May 30, 2013

@author: jdevries
'''
import sys
from string import Template

'''
Error code format:

xyffmmm

x = R for RST
y = W for work item command line, J for Jazzrest module
ff = function:
mmm = message number

'''

jazzrest_messages = {
 "RJ00000": "Unexpected exception: $exception",
 # network errors ff=01
 "RJ01001": "Connection problem. Check the repository URL and network connection. Caused by: $exception",
 # HTTP errors ff=02
 "RJ02001": "Connection problem. Check the repository URL. HTTP status code $status_code",
 "RJ02002": "Unable to load work item $id",
 "RJ02003": "Unable to subscribe. $message",
 "RJ02004": "Unable to unsubscribe. $message",
 "RJ02005": "Unable to add a comment. $message",
 "RJ02006": "Unable to link. $message",
 "RJ02007": "Unable to unlink. $message",
 "RJ02008": "Unable to modify work item. $message",
 "RJ02009": "Unable to create work item. $message",
 "RJ02010": "Unable to list queries. $message",
 "RJ02011": "Unable to run query. $message",
        
 # Invalid value problems not related to network or HTTP errors: ff=03
 "RJ03001": "Could not sign in to $repository as $user. Check user ID and password.",
 "RJ03002": "Could not find project: $project",
 "RJ03005": "Project parameter not specified.",
 "RJ03112": "Invalid work item type $witype",
 "RJ03113": "Invalid work item name $winame",
 "RJ03114": "Invalid action ID $actionid",
 "RJ03115": "Invalid action name $actionname",
 "RJ03116": "Invalid user ID $person",
 "RJ03201": "Couldn't find query: $query",
 "RJ03300": "Invalid value for attribute: $attribute : $value",
 "RJ03301": "Unknown attribute: $attribute"

}

def getmsg(name, **kwargs):
    replace = kwargs
    if 'exception' not in replace:
        replace['exception']=sys.exc_info()[1]
    if name in jazzrest_messages:
        rmessage = Template(jazzrest_messages[name]).safe_substitute(replace)
    else:
        rmessage = Template(replace.get('message','')).safe_substitue(replace)
    return rmessage,name