'''
Created on May 8, 2013

@author: jdevries
'''
import time
import json
import jazzrest
import sys

repo=sys.argv[1]
project=sys.argv[2]
user=sys.argv[3]
pwd =sys.argv[4]

rtcsession = jazzrest.RTCSession()
rtcsession.loginNew(repo, user, pwd)
rsess = rtcsession.requestSession
headers = rtcsession.jsonheaders
actionheaders = {'Accept': 'application/json'}


attrexceptions = { 'com.ibm.team.workitem.workItemType.risk.impact': 'Risk Impact',
                  'com.ibm.team.workitem.linktype.resolvesworkitem.resolvedBy': 'Resolved By Link',
                  'rtc_cm:type': 'WI Type'
                  }

witypeexceptions = {
                    }


nslookup = {
        "acp": "http://jazz.net/ns/acp#",
        "dcterms": "http://purl.org/dc/terms/",
        "oslc": "http://open-services.net/ns/core#",
        "oslc_cm": "http://open-services.net/ns/cm#",
        "oslc_cmx": "http://open-services.net/ns/cm-x#",
        "oslc_pl": "http://open-services.net/ns/pl#",
        "rdf": "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
        "rtc_cm": "http://jazz.net/xmlns/prod/jazz/rtc/cm/1.0/",
        "rtc_ext": "http://jazz.net/xmlns/prod/jazz/rtc/ext/1.0/"
}

masterattr = []
mastertypes = set()
witypes = {}
winames = {}
workitems = {}
literals = {}
attrnames = {}
attributes = {}

'''

all Literals are of the form: these should all match whatever the project area?
{REPOSITORY}/oslc/enumerations/{PROJECT_UUID}/{attribute type/attribute literal}
example: https://jazzt1.rchland.ibm.com:11443/ccm/oslc/enumerations/{PROJECT_UUID}/priority/priority.literal.l01

Category - per project area? per work item type in project area?
{REPOSITORY}/resource/itemOid/com.ibm.team.workitem.Category/{CATEGORY UUID}
allowed values: {REPOSITORY}/oslc/context/{PROJECT_UUID}/shapes/workitems/{WITYPE}/property/category/allowedValues

Project: this list is per-repository
{REPOSITORY}/oslc/projectareas/{PROJECT_UUID}
allowed values: {REPOSITORY}/oslc/context/{PROJECT_UUID}/shapes/workitems/{WITYPE}/property/projectArea/allowedValues

Iteration: per project
{REPOSITORY}/oslc/iterations/{ITERATION UUID}
allowed values: {REPOSITORY}/oslc/context/{PROJECT_UUID}/shapes/workitems/{WITYPE}/property/target/allowedValues

Status: state key should be shared across all project areas
{REPOSITORY}/oslc/workflows/{PROJECT_UUID}/states/{WORKFLOW}/{state key}
allowed values: {REPOSITORY}/oslc/context/{PROJECT_UUID}/shapes/workitems/{WITYPE}/property/internalState/allowedValues

Deliverable: per project
{REPOSITORY}/resource/itemOid/com.ibm.team.workitem.Deliverable/{FOUNDIN UUID}
allowed values: {REPOSITORY}/oslc/context/{PROJECT_UUID}/shapes/workitems/{WITYPE}/property/foundIn/allowedValues

Person: always look up somehow
{JTS}/users/{user ID}
allowed values: {REPOSITORY}/context/{PROJECT_UUID}/shapes/workitems/{WITYPE}/property/owner/allowedValues

Type: type of workitem: sort of have this already?
{REPOSITORY}/oslc/types/{PROJECT_UUID}/{workitem ID}
allowed values: {REPOSITORY}/oslc/context/{PROJECT_UUID}/shapes/workitems/{WITYPE}/property/workItemType/allowedValues

Hard code:
Literal, Status




'''

def treaturl(url,r,p):
    #TODO: No keyword replace
    #return url.replace(r, '{REPOSITORY}').replace(p,'{PROJECT_UUID}')
    return url

def getallowedvalues(avlist,project,attrtype):
    rv = {}
    types = set()
    for av in avlist:
        ttype = av['rdf:type'][0]['rdf:resource']
        typen = ttype.split('/')[-1]
        types.add(typen)
        if typen in ['Literal']:
            attrliterals = {}
            if attrtype not in literals:
                literals[attrtype]=attrliterals
            else:
                attrliterals = literals[attrtype]
            du = av['rdf:resource']
            if du in attrliterals:
                print('saving one: '+du)
            else:
                sg = int(round(time.time() * 1000))
                dr = rsess.get(du,headers=headers)
                eg = int(round(time.time() * 1000))
                print('getallowedvalues: '+str(eg-sg)+' '+du)
                desc = json.loads(dr.text)
                #hn = desc['rtc_cm:hierarchicalName']
                t = desc['dcterms:title']
                #rv[du]={'title':t}#,'hierarchicalName':hn}
                
                lkey = treaturl(du,repo,project)
                if lkey in attrliterals:
                    tcomp = attrliterals[lkey]
                    if tcomp!=t:
                        print('Literal key: '+attrtype+'::'+lkey+' mismatch: '+tcomp+' <> '+t)
                else:
                    attrliterals[lkey]=t
                    
                if t in attrliterals:
                    tlkey = attrliterals[t]
                    if tcomp!=t:
                        print('Title key: '+attrtype+'::'+t+' mismatch: '+tlkey+' <> '+lkey)
                else:
                    attrliterals[t]=lkey
        elif typen == 'Status':
            du = av['rdf:resource']
            sg = int(round(time.time() * 1000))
            dr = rsess.get(du,headers=headers)
            eg = int(round(time.time() * 1000))
            print('getallowedvalues Status: '+str(eg-sg)+' '+du)
            desc = json.loads(dr.text)
            t = desc['dcterms:title']
            #TODO: no keyword replace
            #lkey = du.replace(repo, '{REPOSITORY}').replace(project,'{PROJECT_UUID}')
            lkey = du
            
            rv[lkey]={'title':t}
            rv[t]={'literal':lkey}
            
            
    if len(types)>1:
        print(types)
    return (types.pop(),rv)

def attachns(base, propdef):
    for (ns,nsu) in nslookup.items():
        if propdef.startswith(nsu):
            return ':'.join([ns,base])
    print('not found URI: '+propdef)
    return base

def shapeparsing(shapeurl,typeName,project):

    #print(shapeurl)
    wtid = typeName
    sg = int(round(time.time() * 1000))
    sr = rsess.get(shapeurl,headers=headers)
    eg = int(round(time.time() * 1000))
    print('shapeparsing: '+str(eg-sg)+' '+shapeurl)
    
    shapes = json.loads(sr.text)
    uname = shapes["dcterms:title"]
    
    sprops = shapes['oslc:property']
    xprops = {} # map between literal and end-user
    statusinfo = None
    for p in sprops:
        ''' p is a dictionary '''
        ''' ignore rdf:type, oslc:readOnly, oslc:occurs, rdf:about = URL that might be useful for additional work '''
        ''' use: dcterms:title=user name, oslc:name=literal name,  ''' 
        ''' unknown: oslc:propertyDefinition : might need this to differentiate stuff '''
        tl = p['oslc:name']
        l = attachns(tl,p['oslc:propertyDefinition']['rdf:resource'])
        if l in attributes:
            nd=attributes[l]
            atype=nd.get('avtype','')
            e = nd.get('username',None)
        else:
            te = attrexceptions.get(tl,None)
            if te == None:
                te = attrexceptions.get(l,p['dcterms:title'])
            e = te
            a = p['rdf:about']
            nd = {'username': e}
            vt = p['oslc:valueType']['rdf:resource'].split('#')[-1]
            #rt = p.get('oslc:representation',{}).get('rdf:resource','').split('#')[-1]
            nd['type']=vt
            #nd['representation']=rt
            nd['about']=treaturl(a,repo,project)
            atype=''
            if 'oslc:allowedValues' in p:
                #if vt=='string':
                #    print('has allowed values: '+vt+' '+l)
                av = treaturl(p['oslc:allowedValues']['rdf:about'],repo,project).replace(wtid,'{WITYPE}')
                nd['allowedValuesURL'] = av
                #(atype, avl) = getallowedvalues(p['oslc:allowedValues']['oslc:allowedValue'],project,l)
                #nd['allowedValues'] = avl
                #nd['avtype']=atype
                mastertypes.add(atype)
        
        if l not in xprops and atype=='Status':
            statusinfo = (l,nd)
            xprops[l]=nd

        if e not in attrnames:
            attrnames[e]=l
        else:
            if attrnames[e]!=l:
                print('Name mismatch: '+e+' == '+attrnames[e]+' <> '+l)
 
        
        if l not in attributes and atype!='Status':
            attributes[l]=nd
        else:
            # could compare attribute values to see if it's all the same
            pass
        
    
    actions = {}
    actionuri = None
    
    if statusinfo != None:
        av = statusinfo[1].get('allowedValues',{})
        for n in av.keys():
            #TODO: no keyword replace
            #if n.startswith('{REPOSITORY}'):
            if n.startswith(repo):
                #actionuri = n.replace('{REPOSITORY}',repo).replace('{PROJECT_UUID}',project).replace('/states/','/actions/')
                actionuri = n.replace('/states/','/actions/')
                
                actionuri = actionuri.rsplit('/',1)[0]
                print(actionuri)
                break
        if actionuri != None:
            sg = int(round(time.time() * 1000))
            r = rsess.get(actionuri, headers=actionheaders)
            eg = int(round(time.time() * 1000))
            print('shapeparsing: '+str(eg-sg)+' '+shapeurl)
            al = json.loads(r.text)
            details = {}
            titles = {}
            for x in al:
                resultState = treaturl(x['rtc_cm:resultState']['rdf:resource'],repo,project)
                actionid = x['dc:identifier']
                title = x['dc:title']
                
                details[actionid]={'resultState':resultState,'title':title}
                titles[title]=actionid
            
            actions['details']=details
            actions['names']=titles
                    
    
    
    shape = {'username':uname,'attributes':xprops,'actions':actions,'actionuri':actionuri}
    
    return shape

def compareattr(attr1, attr2):
    ns = False
    avs = False
    
    if attr1['username']==attr2['username']:
        ns = True
    else:
        print('Different names: '+attr1['username']+' <> '+attr2['username'])
    
    if 'allowedValues' not in attr1 and 'allowedValues' not in attr2:
        # no allowed values specified, it's ok
        avs = True
    elif 'allowedValues' in attr1 and 'allowedValues' in attr2:
        avs = True
    else:
        avs = False
        print("One doesn't have allowed values"+attr1['username']+' <> '+attr2['username'])
    
    return ns & avs

def comparewitypes(d1, d2):
    # compare work item types:
    rval = False
    if d1['username']==d2['username']:
        d1t = set(d1['attributes'].keys())
        d2t = set(d2['attributes'].keys())
        nid2 = d1t - d2t
        nid1 = d2t - d1t
        if len(nid2) != 0 or len(nid1) != 0:
            print('Not in d2: '+str(nid2))
            print('Not in d1: '+str(nid1))
        
        kset = d1t & d2t
    
        for k in kset:
            d1v = d1['attributes'].get(k)
            d2v = d2['attributes'].get(k)
            rval = compareattr(d1v,d2v)

    else:
        print('Names are different')
        rval = False
    
    return rval
        

def readproject(proj):
    pname = proj['dcterms:title']
    url = proj['rdf:about']
    project_uuid = proj['oslc:details'][0]['rdf:resource'].split('/')[-1]
    
    print('scanning: '+pname+' '+url)
    sr = rsess.get(url, headers=headers)
    services = json.loads(sr.text).get("oslc:service",[])
    # ignore: rdf:type, oslc:details, dcterms:title, prefixes, rdf:about, dcterms:publisher

    for service in services:
        
        factories = service.get("oslc:creationFactory",[])
        for fi in factories:
            tl = fi["oslc:resourceType"]
            typeName = None
            for tg in tl:
                if tg["rdf:resource"].startswith(repo):
                    typeName = tg["rdf:resource"]
            if typeName != None:
                print('starting: '+typeName)
                cfURL=fi["oslc:creation"]["rdf:resource"]
                shapeURL=fi["oslc:resourceShape"]["rdf:resource"]
                typeName = typeName.split('/')[-1]
                sg = int(round(time.time() * 1000))
                attrs = shapeparsing(shapeURL,typeName,project_uuid)
                eg = int(round(time.time() * 1000))
                print('shapeparsing total: '+str(eg-sg)+' '+typeName)
                tun = attrs['username']
                if typeName not in witypes:
                    print(pname+' new type: '+typeName)
                    witypes[typeName]=attrs
                    if tun not in winames:
                        winames[tun]=typeName
                    elif winames[tun]!=typeName:
                        print('Type Name problem: '+tun+' == '+typeName+' | '+winames[tun])
                '''
                else:
                    equiv = comparewitypes(witypes[typeName],attrs)
                    if not equiv:
                        print('+++++++++++++++Project: '+pname+' '+typeName)
                '''

rv = rsess.get(repo+'/oslc/workitems/catalog', headers=headers)
catalog = json.loads(rv.text)
plist = catalog["oslc:serviceProvider"]
pcount = 0
for proj in plist:
    pname = proj['dcterms:title']
    if pname == project:
        starttime = int(round(time.time() * 1000))
        readproject(proj)
                    
        pcount = pcount + 1
        #if pcount > 0:
        #    break
        endtime = int(round(time.time() * 1000))
        duration = endtime-starttime
        print("Duration ms: "+str(duration))

lfp = open('literals.json','w')
json.dump(literals,lfp,sort_keys=True,indent=4,separators=(',',': '))
lfp.close()

workitems = {'names':winames,'details':witypes}
wtfp = open('workitemtypes.json','w')
json.dump(workitems,wtfp,sort_keys=True,indent=4,separators=(',',': '))
wtfp.close()
afp = open('attributes.json','w')
json.dump({'names':attrnames,'details':attributes},afp,sort_keys=True,indent=4,separators=(',',': '))
afp.close()
print('types: '+str(len(witypes))+' attributes: '+str(len(attributes))+' literals: '+str(len(literals)))
