'''
Created on May 30, 2013

@author: jdevries
'''
import sys
from string import Template

'''
Error code format:

xyffmmm

x = R for RST
y = W for work item command line, J for Jazzrest module
ff = function:
mmm = message number

'''
wi_messages = {
 "RW00000": "Unexpected exception: $exception",
 #missing parameters: ff=03
 "RW03002": "Cannot sign in: No user ID provided for repository $repository",
 "RW03003": "Need password to sign in.",
 "RW03004": "Missing repository parameter.",
 "RW03005": "Missing project parameter.",
 "RW03006": "Invalid repository URL: $url",
 "RW03100": "No work item type specified for create command.",
 "RW03101": "No work item ID specified for command: $command",
 "RW03102": "No action specified for change state command.",
 "RW03103": "No comment specified.",
 "RW03104": "No link type specified for $command command.",
 "RW03105": "No link specified for $command command.",
 "RW03106": "No query name specified for runquery command.",
 "RW03107": "No topic specified for list command. See help list for more information",
 "RW03108": "Invalid topic for list command: $topic",
 "RW03109": "Work item type not specified for list actions command",
 "RW03110": "Field name not specified for list values command",
 "RW03111": "Work item type not specified for list attributes command",
 "RW03112": "Invalid CLEAR mode: $clearmode",
 
 "RW03201": "Invalid value for -V (--verbosity) option: $parameter",
 "RW03202": "Invalid value for -x (--translate) option: $parameter",
 
 #parsing input: ff=04
 "RW04001": "Could not parse input file '$inputfile' Caused by: $exception",
 "RW04002": "Could not parse standard input. Caused by: $exception",
 "RW04003": "Could not parse command line field values. Caused by: $exception Input: $jsonval",

 #internal operations ff=09
 "RW09001": "Unable to remove files: $files",
 "RW09002": "Couldn't open browser for URL: $url"
}

def getmsg(name, **kwargs):
    replace = kwargs
    if 'exception' not in replace:
        replace['exception']=sys.exc_info()[1]
    if name in wi_messages:
        rmessage = Template(wi_messages[name]).safe_substitute(replace)
    else:
        rmessage = Template(replace.get('message','')).safe_substitue(replace)
    return rmessage,name