'''
Created on May 2, 2013

@author: jdevries
'''

'''
Setup script for creating the distribution file for RTCWI

files needed:
 |-jazzrest/ [ jazzrest folder from oslccore project]
 |-rtccli/ [ rtccli folder from rtccli project]
 |-scripts/ [ scripts folder from rtccli project]
 |-MANIFEST.in [ from rtccli project]
 |-setup.py [ from rtccli project]

create zip & tar.gz distribution: (probably just want to standardize on one of these if all platforms can use the same one)
python setup.py sdist --formats=gztar,zip


Update notes:
1. Keep the package_data parameter up to date with any new data files added in packages
2. Version number
3. Requests version

'''

from distutils.core import setup

# TODO: build the version number
# yy.Q.mmdd.hhmm
genversion = '13.3'

setup(name='rtcwi',
      version=genversion,
      description='RTC Work Item Command Line Interface',
      maintainer='STG Rational Solutions Team',
      maintainer_email='stgjazz@us.ibm.com',
      packages=['rtccli','jazzrest'],
      package_dir={'jazzrest': 'jazzrest'},
      package_data={'jazzrest': ['*.json']},
      url='https://stgdoc.rchland.ibm.com/STGC/rtcwicli',
      install_requires=['requests==1.2.0'],
      scripts=['scripts/rtcwi.py']
      )